# coding:utf8

__author__ = 'dong'

import os
import logging
import xml.dom.minidom
import re
import shutil
import glob
from xml.etree.ElementTree import ElementTree, Element
import distutils.dir_util
from xml.etree import ElementTree as ET
import gw_file_system
import gw_data_center

ANDROID_NS = 'http://schemas.android.com/apk/res/android'


def script_init(workspace_sdk_dir, extract_dir, channel_sdk_info, new_game_channel_info, game_info):
    # gw_data_center.pack_small=True
    return


def script_second(workspace_sdk_dir, extract_dir, channel_sdk_info, new_game_channel_info, game_info):
    logging.info('script_second: ' + str(channel_sdk_info))
    # 逆向渠道id
    if channel_sdk_info['id'] == '549':
        public_xml = os.path.join(extract_dir, "../sdk/smallsheep/ForRes/values/public.xml")
        handle_public_xml(public_xml, "abc_list_pressed_holo_dark")

        public_xml = os.path.join(extract_dir, "../sdk/smallsheep/ForRes/values/public.xml")
        handle_public_xml(public_xml, "abc_list_selector_disabled_holo_dark")

        public_xml = os.path.join(extract_dir, "../sdk/smallsheep/ForRes/values/public.xml")
        handle_public_xml(public_xml, "abc_list_selector_background_transition_holo_dark")

        public_xml = os.path.join(extract_dir, "../sdk/smallsheep/ForRes/values/public.xml")
        handle_public_xml(public_xml, "abc_list_selector_holo_dark")

        public_xml = os.path.join(extract_dir, "../sdk/smallsheep/ForRes/values/public.xml")
        handle_public_xml(public_xml, "abc_item_background_holo_dark")

        public_xml = os.path.join(extract_dir, "../sdk/smallsheep/ForRes/values/styles.xml")
        handle_public_xml(public_xml, "abc_list_selector_holo_dark")

        public_xml = os.path.join(extract_dir, "../sdk/smallsheep/ForRes/values/styles.xml")
        handle_public_xml(public_xml, "abc_item_background_holo_dark")

        public_xml = os.path.join(extract_dir, "../sdk/smallsheep/ForRes/drawable/abc_item_background_holo_dark.xml")
        if os.path.exists(public_xml):
            os.remove(public_xml)

        public_xml = os.path.join(extract_dir,
                                  "../sdk/smallsheep/ForRes/drawable/abc_list_selector_background_transition_holo_dark.xml")
        if os.path.exists(public_xml):
            os.remove(public_xml)

        public_xml = os.path.join(extract_dir, "../sdk/smallsheep/ForRes/drawable/abc_list_selector_holo_dark.xml")
        if os.path.exists(public_xml):
            os.remove(public_xml)

        public_xml = os.path.join(extract_dir,
                                  "../sdk/smallsheep/ForRes/drawable-mdpi/abc_list_pressed_holo_dark.9.png")
        logging.info("public_xml:" + public_xml)
        if os.path.exists(public_xml):
            os.remove(public_xml)

        public_xml = os.path.join(extract_dir,
                                  "../sdk/smallsheep/ForRes/drawable-hdpi/abc_list_pressed_holo_dark.9.png")
        if os.path.exists(public_xml):
            os.remove(public_xml)

        public_xml = os.path.join(extract_dir,
                                  "../sdk/smallsheep/ForRes/drawable-xhdpi/abc_list_pressed_holo_dark.9.png")
        if os.path.exists(public_xml):
            os.remove(public_xml)

        public_xml = os.path.join(extract_dir,
                                  "../sdk/smallsheep/ForRes/drawable-xxhdpi/abc_list_pressed_holo_dark.9.png")
        if os.path.exists(public_xml):
            os.remove(public_xml)

        public_xml = os.path.join(extract_dir,
                                  "../sdk/smallsheep/ForRes/drawable-mdpi/abc_list_selector_disabled_holo_dark.9.png")
        if os.path.exists(public_xml):
            os.remove(public_xml)

        public_xml = os.path.join(extract_dir,
                                  "../sdk/smallsheep/ForRes/drawable-hdpi/abc_list_selector_disabled_holo_dark.9.png")
        if os.path.exists(public_xml):
            os.remove(public_xml)

        public_xml = os.path.join(extract_dir,
                                  "../sdk/smallsheep/ForRes/drawable-xhdpi/abc_list_selector_disabled_holo_dark.9.png")
        if os.path.exists(public_xml):
            os.remove(public_xml)

        public_xml = os.path.join(extract_dir,
                                  "../sdk/smallsheep/ForRes/drawable-xxhdpi/abc_list_selector_disabled_holo_dark.9.png")
        if os.path.exists(public_xml):
            os.remove(public_xml)


def handle_public_xml(public_xml_path, remove_node):
    if not os.path.exists(public_xml_path):
        logging.info('public_xml is null: ' + public_xml_path)
        return
    new_lines = []
    with open(public_xml_path, 'r+') as f:
        for line in f.readlines():
            # l = line.strip()
            if line.find(remove_node) > -1:
                continue
            new_lines.append(line)
        f.seek(0)
        f.truncate()
        f.writelines(new_lines)
    return


def script(SDK, decompileDir, channelSdkInfo, new_game_channel_info, gameInfo):
    logging.info("-----debug-----")


def script_last(SDK, decompileDir, channelSdkInfo, new_game_channel_info, gameInfo):
    return


def create_mutil_smali(decompileDir):
    f_idx = 2
    while True:
        tmp = gw_file_system.get_full_path(os.path.join(decompileDir, 'smali_classes%d' % f_idx))
        tmp = tmp.replace('\\', '/')
        tmp = re.sub('/+', '/', tmp)
        if os.path.exists(tmp):
            f_idx += 1
        else:
            smali_classes2_dir = tmp
            break
    # endwhile
    os.mkdir(smali_classes2_dir)
    return smali_classes2_dir


def move_package(s1, s3, list_package):
    for d in list_package:
        src = os.path.join(s1, d)
        if os.path.exists(src):
            dst = os.path.join(s3, d)
            distutils.dir_util.copy_tree(src, dst)
            distutils.dir_util.remove_tree(src)


def move_package_one(src, dst):
    if os.path.exists(src):
        distutils.dir_util.copy_tree(src, dst)
        distutils.dir_util.remove_tree(src)


change_map = {".super Landroid/app/Application;": ".super Lcom/kf/framework/KFApplication;",
              "invoke-direct {p0}, Landroid/app/Application;-><init>()V": "invoke-direct {p0}, Lcom/kf/framework/KFApplication;-><init>()V",
              "invoke-super {p0, p1}, Landroid/app/Application;->attachBaseContext(Landroid/content/Context;)V": "invoke-super {p0, p1}, Lcom/kf/framework/KFApplication;->attachBaseContext(Landroid/content/Context;)V",
              "invoke-super {p0}, Landroid/app/Application;->onCreate()V": "invoke-super {p0}, Lcom/kf/framework/KFApplication;->onCreate()V", }


def replace_super_application(decompileDir):
    smali_files = glob.glob(
        os.path.join(decompileDir, 'smali*/com/radical/huangshangjixiang/qh360/CoronaApplication.smali'))
    if len(smali_files) == 1:
        game_application_file = smali_files[0];
        print game_application_file
        if os.path.isfile(game_application_file):
            with open(game_application_file, "r+") as f:
                file_str = f.read()
                for k, v in change_map.items():
                    file_str = file_str.replace(k, v)
            with open(game_application_file, "w+") as f:
                f.write(file_str)


def modify_manifest(decompileDir, removeKey):
    ET.register_namespace('android', ANDROID_NS)
    xmlparse = os.path.join(decompileDir, 'AndroidManifest.xml')
    root_node = ET.parse(xmlparse)
    root = root_node.getroot()
    name = '{' + ANDROID_NS + '}name'
    authorities = '{' + ANDROID_NS + '}' + removeKey
    package_name = root.attrib.get('package')
    if package_name == None:
        return
    providers = root.findall('./application')
    if providers != None:
        for provider in providers:
            # providerName = provider.attrib.get(name)
            # if 'com.netease.ntunisdk.CcMomentRecordingForegroundService' == providerName:
            # 使用try 主要是为了 防止此属性不在时，导致的错误，而程序终止
            try:
                del provider.attrib[authorities]
            except:
                ""

    root_node.write(xmlparse, 'utf-8')


def handle_public_xml(public_xml_path, remove_node):
    if not os.path.exists(public_xml_path):
        logging.info('public_xml is null: ' + public_xml_path)
        return
    new_lines = []
    with open(public_xml_path, 'r+') as f:
        for line in f.readlines():
            # l = line.strip()
            if line.find(remove_node) > -1:
                continue
            new_lines.append(line)
        f.seek(0)
        f.truncate()
        f.writelines(new_lines)
    return


if __name__ == '__main__':
    # replace_super_application("D:\work\wzdq")
    modify_manifest("E:\\apk\\youhua\\youhua.zip.out", "requestLegacyExternalStorage")
